#!/usr/bin/perl
$| = 1;

use strict;
use lib './extlib';
use CGI::Carp qw(fatalsToBrowser);
use WWW::Mixi;
use Jcode;
use Digest::MD5;
use Data::Dumper;#DEBUG

use vars qw($MYNAME $VERSION $RELEASE);
$MYNAME = 'mixi2ical';
$VERSION = '0.10';
$RELEASE = '060910';



;### CGI Ȥư硤0 ʳ
use constant WORK_AS_CGI =>		1;

;### mixi Υ
use constant MIXI_MAILADDR =>	'ˤʤ mixi 󥢥';
use constant MIXI_PASSWORD =>	'ˤʤ mixi ѥ';

;### 塼1 ʾ塣
;### 3 ä麣ʬ롣
use constant MONTHS =>			3;



;### ȥ
printf STDERR <<PERLHEREDOC unless WORK_AS_CGI;
$MYNAME - Convert events in mixi schedule into iCal format.
		Version $VERSION Release $RELEASE
		Programmed by Piroli YUKARINOMIYA (MagicVox)
		@see http://www.magicvox.net/archive/2006/09102208.phpve/2006/
PERLHEREDOC

;### CGI إå
printf STDOUT <<PERLHEREDOC if WORK_AS_CGI;
Content-Type: text/calendar; charset=utf-8

PERLHEREDOC



;### mixi Υ쥤ԥ󥰤ˤ WWW::Mixi ȤäƤޤ
printf STDERR "Starting process ..." unless WORK_AS_CGI;
my $mixi = WWW::Mixi->new (MIXI_MAILADDR, MIXI_PASSWORD);
unless ($mixi) {
	printf STDERR "\n\tinitialize failure: WWW::Mixi\n"; exit;
}
printf STDERR "OK\n" unless WORK_AS_CGI;

;### ȾȤäƥߤ
printf STDERR "Tring to login ..." unless WORK_AS_CGI;
my $res = $mixi->login ();
unless ($mixi->is_logined) {
	printf STDERR "\n\tlogin failure\n". $res->content; exit;
}
printf STDERR "done\n" unless WORK_AS_CGI;

;### MONTHS ǻꤵ줿ʬͽɽ
printf STDERR "Retrieving pages " unless WORK_AS_CGI;
my @event_items = ();
my $calendar_url = 'show_calendar.pl';
foreach my $month (0..MONTHS-1) {
	printf STDERR "." unless WORK_AS_CGI;
	$res = $mixi->get ($calendar_url);
	last unless $res;

	;# ڡǯ/
	my $term = $mixi->parse_show_calendar_term ($res);
	$term->{month} += $month;
	($term->{month} -= 12, $term->{year}++) if 12 < $term->{month};
	$term->{month} = '0'. $term->{month} if $term->{month} < 10;

	;# ƥդ񤭴(WWW::Mixi ΥХ)
	my @items = $mixi->parse_show_calendar ($res);
	foreach my $item (@items) {
		$item->{time} =~ s!\d+/\d+/(\d+)!$term->{year}$term->{month}$1!;
		push @event_items, $item;
	}

	;# 
	my $link_next = $mixi->parse_show_calendar_next ($res);
	last unless $link_next;
	$calendar_url = $link_next->{link};
}
printf STDERR "done\n" unless WORK_AS_CGI;

;### iCal եޥåѴΤ
;### ʤܤϹƬ # 񤭲äƤ
my $callbacks = {
		'i_sc-.gif' => { name => 'ͽ', func => \&iCalSchedule },
		'i_bd.gif' => { name => '', func => \&iCalBirthday },
		'i_iv1.gif' => { name => 'å٥', func => \&iCalEventBooked },
#		'i_iv2.gif' => { name => '٥', func => \&iCalEvent },
};

;### iCal ǡι
printf STDERR "Generating iCal " unless WORK_AS_CGI;
my $iCal = &iCalHeader ();
foreach my $item (@event_items) {
	my ($icon) = $item->{icon} =~ m!.+/(.+)$!;
	unless ($callbacks->{$icon}) {
		printf STDERR "?" unless WORK_AS_CGI; next;
	}
	printf STDERR "." unless WORK_AS_CGI;

	;# ǡ
	$item->{UID} = $MYNAME. '/'. Digest::MD5::md5_hex ($item->{link});

	;# ٥ȼ iCal ǡѴ
	$iCal .= $callbacks->{$icon}->{func} ($callbacks->{$icon}->{name}, $item);
}
$iCal .= &iCalFooter ();
printf STDERR "done\n" unless WORK_AS_CGI;

;### 
printf STDOUT jcode ($iCal)->h2z->utf8;
exit;



;### ̤ɲäͽ
sub iCalSchedule {
	my ($name, $item) = @_;
	return <<ICALHEREDOC;
BEGIN:VEVENT
UID:$item->{UID}
DESCRIPTION:[$item->{subject}] $item->{name} ($item->{link})
DTSTART:$item->{time}
SUMMARY:[$item->{subject}] $item->{name}
END:VEVENT
ICALHEREDOC
}

;### 
sub iCalBirthday {
	my ($name, $item) = @_;
	return <<ICALHEREDOC;
BEGIN:VEVENT
UID:$item->{UID}
DESCRIPTION:[$item->{subject}] $item->{name} ($item->{link})
DTSTART:$item->{time}
SUMMARY:[$item->{subject}] $item->{name}
END:VEVENT
ICALHEREDOC
}

;### ͽΥ٥
sub iCalEventBooked {
	my ($name, $item) = @_;
	return <<ICALHEREDOC;
BEGIN:VEVENT
UID:$item->{UID}
DESCRIPTION:[$item->{subject}] $item->{name} ($item->{link})
DTSTART:$item->{time}
SUMMARY:[$item->{subject}] $item->{name}
END:VEVENT
ICALHEREDOC
}

;### ٥
sub iCalEvent {
	my ($name, $item) = @_;
	return <<ICALHEREDOC;
BEGIN:VEVENT
UID:$item->{UID}
DESCRIPTION:[$item->{subject}] $item->{name} ($item->{link})
DTSTART:$item->{time}
SUMMARY:[$item->{subject}] $item->{name}
END:VEVENT
ICALHEREDOC
}



;### iCal إå
sub iCalHeader {
	<<PERLHEREDOC;
BEGIN:VCALENDAR
VERSION:2.0
PRODID:-//MagicVox//$MYNAME $VERSION//ES
METHOD:PUBLISH
CALSCALE:GREGORIAN
X-WR-CALNAME:mixiͽɽ
X-WR-CALDESC:mixiͽɽPerḷiCal
X-WR-TIMEZONE:Asia/Tokyo
PERLHEREDOC
}

;### iCal եå
sub iCalFooter {
	<<PERLHEREDOC;
BEGIN:VTIMEZONE
TZID:Asia/Tokyo
BEGIN:STANDARD
DTSTART:19700101T000000
TZOFFSETFROM:+0900
TZOFFSETTO:+0900
END:STANDARD
END:VTIMEZONE
END:VCALENDAR
PERLHEREDOC
}



1;
__END__
